<template>
  <v-dialog
    :value="value"
    max-width="290"
    @keydown.esc="closeRequest"
    @click:outside="closeRequest"
    content-class="round"
  >
    <div class="flex flex-col bg-white p-5 items-center justify-between gap-8">
      <div class="text-xl font-semibold">{{ title }}</div>
      <div class="flex flex-col">
        <div class="flex flex-row gap-5">
          <div class="text-sm">
            <v-form
              ref="form"
              v-model="valid"
              @submit.prevent="onModalSubmit()"
            >
              <v-text-field
                label="Nom"
                id="nom"
                required
                v-model="bulletin.nom"
                :rules="nomRules"
              ></v-text-field>
              <v-dialog ref="dialog" v-model="modal" width="290px">
                <template v-slot:activator="{ on, attrs }">
                  <v-text-field
                    label="Date de remise"
                    v-model="formattedDateString"
                    required
                    readonly
                    :rules="dateRules"
                    v-bind="attrs"
                    v-on="on"
                  ></v-text-field>
                </template>
                <v-date-picker
                  v-model="bulletin.date"
                  scrollable
                  class="border-none"
                  locale="fr-fr"
                >
                  <v-btn text color="primary" @click="modal = false">
                    Annuler
                  </v-btn>
                  <v-btn text color="primary" @click="$refs.dialog.save(date)">
                    OK
                  </v-btn>
                </v-date-picker>
              </v-dialog>
              <div class="flex flex-row-reverse justify-between gap-5">
                <div>
                  <button
                    type="submit"
                    @click="onModalSubmit()"
                    class="bg-bleu font-medium text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
                  >
                    {{ updating ? "Modifier" : "Ajouter" }}
                  </button>
                </div>
                <div
                  id="deleteMatCompSav"
                  @click="onModalSubmit('delete')"
                  class="cursor-pointer border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
                  v-show="updating"
                >
                  Effacer
                </div>
              </div>
            </v-form>
          </div>
        </div>
      </div>
    </div>
  </v-dialog>
</template>

<script>
export default {
  emits: ["closeRequest"],
  props: { value: Boolean, updatedBulletin: Object },

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },
    onModalSubmit(deleting = false) {
      if (this.$refs.form.validate()) {
        if (deleting == false) {
          this.$store.dispatch("addBulletin", {
            ...this.bulletin,
            classe: this.classe,
          });
        } else this.$store.dispatch("deleteBulletin", this.bulletin);
        this.closeRequest();
      }
    },
  },

  data() {
    return {
      valid: false,
      updating: Object.keys(this.updatedBulletin).length != 0,
      bulletin: { ...this.updatedBulletin } ?? {},

      nomRules: [(v) => !!v || "Le nom est requis"],
      dateRules: [(v) => !!v || "La date est requis"],
      modal: false,
    };
  },

  computed: {
    title() {
      return this.updating
        ? `Modifier le savoir ${this.updatedBulletin.nom}`
        : `Ajouter un bulletin`;
    },
    formattedDateString() {
      return new Date(this.bulletin?.date ?? new Date()).toLocaleDateString();
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
};
</script>
